﻿BetterMagnet = LibStub("AceAddon-3.0"):NewAddon("BetterMagnet", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("BetterMagnet")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")

local defaults = {
	char = {
		['lootGold'] = true,
		['itemsYouHave'] = true,
		['lootQuality'] = {
			[0] = true,
			[1] = false,
			[2] = true,
			[3] = true,
			[4] = false,
			[5] = false,
			[6] = false
		},

		['Armor'] = {
			['Cloth'] = true,
			['Cloth_BoU'] = true,
			['Cloth_BoE'] = true,
			['Cloth_BoP'] = false,
			['Leather'] = true,
			['Leather_BoU'] = true,
			['Leather_BoE'] = true,
			['Leather_BoP'] = false,
			['Mail'] = true,
			['Mail_BoU'] = true,
			['Mail_BoE'] = true,
			['Mail_BoP'] = false,
			['Plate'] = true,
			['Plate_BoU'] = true,
			['Plate_BoE'] = true,
			['Plate_BoP'] = false,
			
			['Idols'] = true,
			['Idols_BoU'] = true,
			['Idols_BoE'] = true,
			['Idols_BoP'] = false,
			['Librams'] = true,
			['Librams_BoU'] = true,
			['Librams_BoE'] = true,
			['Librams_BoP'] = false,
			['Shields'] = true,
			['Shields_BoU'] = true,
			['Shields_BoE'] = true,
			['Shields_BoP'] = false,
			['Totems'] = true,
			['Totems_BoU'] = true,
			['Totems_BoE'] = true,
			['Totems_BoP'] = false,
			['Sigils'] = true,
			['Sigils_BoU'] = true,
			['Sigils_BoE'] = true,
			['Sigils_BoP'] = false,
			['Miscellaneous'] = true,
			['Miscellaneous_BoU'] = true,
			['Miscellaneous_BoE'] = true,
			['Miscellaneous_BoP'] = false
		},
		['Consumable'] = {
			['Bandage'] = true,
			['Consumable'] = true,
			['Elixir'] = true,
			['Flask'] = true,

			['Food & Drink'] = true,
			['Item Enhancements'] = true,
			['Potion'] = true,
			['Scroll'] = true,
			['Other'] = true
		},
		['Containers'] = {
			['Bag'] = true,
			['Enchanting Bag'] = true,
			['Engineering Bag'] = true,
			['Gem Bag'] = true,
			['Herb Bag'] = true,
			['Inscription Bag'] = true,
			['Leatherworking Bag'] = true,
			['Mining Bag'] = true,
			['Soul Bag'] = true
		},
		['Currency'] = {
			['Currency'] = true
		},
		['Gem'] = {
			['Red'] = true,
			['Blue'] = true,
			['Yellow'] = true,
			['Purple'] = true,
			['Green'] = true,
			['Orange'] = true,
			['Meta'] = true,
			['Simple'] = true,
			['Prismatic'] = true
		},
		['Key'] = {
			['Key'] = true
		},
		['Miscellaneous'] = {
			['Holiday'] = true,
			['Junk'] = true,
			['Reagents'] = true,
			['Mount'] = true,
			['Pet'] = true,
			['Other'] = true
		},
		['Money'] = {
			['Money(OBSOLETE)'] = true
		},
		['Quiver'] = {
			['Quiver'] = true,
			['Ammo Pouche'] = true
		},
		['Quest'] = {
			['Quest'] = true,
			['Quest_BoP'] = true
		},
		['Projectile'] = {
			['Arrow'] = true,
			['Bullet'] = true
		},
		['Recipe'] = {
			['Book'] = true,
			['Alchemy'] = true,
			['Blacksmithing'] = true,
			['Cooking'] = true,
			['Enchanting'] = true,
			['Engineering'] = true,
			['First Aid'] = true,
			['Fishing'] = true,
			['Jewelcrafting'] = true,
			['Leatherworking'] = true,
			['Tailoring'] = true
		},
		['Trade Goods'] = {
			['Armor Enchantment'] = true,
			['Armor Enchantment_BoU'] = true,
			['Armor Enchantment_BoE'] = true,
			['Armor Enchantment_BoP'] = false,
			['Cloth'] = true,
			['Cloth_BoU'] = true,
			['Cloth_BoE'] = true,
			['Cloth_BoP'] = false,
			['Device'] = true,
			['Device_BoU'] = true,
			['Device_BoE'] = true,
			['Device_BoP'] = false,
			['Elemental'] = true,
			['Elemental_BoU'] = true,
			['Elemental_BoE'] = true,
			['Elemental_BoP'] = false,
			['Enchanting'] = true,
			['Enchanting_BoU'] = true,
			['Enchanting_BoE'] = true,
			['Enchanting_BoP'] = false,
			['Explosive'] = true,
			['Explosive_BoU'] = true,
			['Explosive_BoE'] = true,
			['Explosive_BoP'] = false,
			['Herb'] = true,
			['Herb_BoU'] = true,
			['Herb_BoE'] = true,
			['Herb_BoP'] = false,
			['Jewelcrafting'] = true,
			['Jewelcrafting_BoU'] = true,
			['Jewelcrafting_BoE'] = true,
			['Jewelcrafting_BoP'] = false,
			['Leather'] = true,
			['Leather_BoU'] = true,
			['Leather_BoE'] = true,
			['Leather_BoP'] = false,
			['Materials'] = true,
			['Materials_BoU'] = true,
			['Materials_BoE'] = true,
			['Materials_BoP'] = false,
			['Meat'] = true,
			['Meat_BoU'] = true,
			['Meat_BoE'] = true,
			['Meat_BoP'] = false,
			['Metal & Stone'] = true,
			['Metal & Stone_BoU'] = true,
			['Metal & Stone_BoE'] = true,
			['Metal & Stone_BoP'] = false,
			['Parts'] = true,
			['Parts_BoU'] = true,
			['Parts_BoE'] = true,
			['Parts_BoP'] = false,
			['Weapon Enchantment'] = true,
			['Weapon Enchantment_BoU'] = true,
			['Weapon Enchantment_BoE'] = true,
			['Weapon Enchantment_BoP'] = false,
			['Other'] = true,
			['Other_BoU'] = true,
			['Other_BoE'] = true,
			['Other_BoP'] = true
		},
		['Weapon'] = {
			['Daggers'] = true,
			['Daggers_BoU'] = true,
			['Daggers_BoE'] = true,
			['Daggers_BoP'] = false,
			['Fist Weapons'] = true,
			['Fist Weapons_BoU'] = true,
			['Fist Weapons_BoE'] = true,
			['Fist Weapons_BoP'] = false,
			['One-Handed Axes'] = true,
			['One-Handed Axes_BoU'] = true,
			['One-Handed Axes_BoE'] = true,
			['One-Handed Axes_BoP'] = false,
			['One-Handed Maces'] = true,
			['One-Handed Maces_BoU'] = true,
			['One-Handed Maces_BoE'] = true,
			['One-Handed Maces_BoP'] = false,
			['One-Handed Swords'] = true,
			['One-Handed Swords_BoU'] = true,
			['One-Handed Swords_BoE'] = true,
			['One-Handed Swords_BoP'] = false,
			['Polearms'] = true,
			['Polearms_BoU'] = true,
			['Polearms_BoE'] = true,
			['Polearms_BoP'] = false,
			['Staves'] = true,
			['Staves_BoU'] = true,
			['Staves_BoE'] = true,
			['Staves_BoP'] = false,
			['Two-Handed Axes'] = true,
			['Two-Handed Axes_BoU'] = true,
			['Two-Handed Axes_BoE'] = true,
			['Two-Handed Axes_BoP'] = false,
			['Two-Handed Maces'] = true,
			['Two-Handed Maces_BoU'] = true,
			['Two-Handed Maces_BoE'] = true,
			['Two-Handed Maces_BoP'] = false,
			['Two-Handed Swords'] = true,
			['Two-Handed Swords_BoU'] = true,
			['Two-Handed Swords_BoE'] = true,
			['Two-Handed Swords_BoP'] = false,
			['Bows'] = true,
			['Bows_BoU'] = true,
			['Bows_BoE'] = true,
			['Bows_BoP'] = false,
			['Crossbows'] = true,
			['Crossbows_BoU'] = true,
			['Crossbows_BoE'] = true,
			['Crossbows_BoP'] = false,
			['Guns'] = true,
			['Guns_BoU'] = true,
			['Guns_BoE'] = true,
			['Guns_BoP'] = false,
			['Thrown'] = true,
			['Thrown_BoU'] = true,
			['Thrown_BoE'] = true,
			['Thrown_BoP'] = false,
			['Wands'] = true,
			['Wands_BoU'] = true,
			['Wands_BoE'] = true,
			['Wands_BoP'] = false,
			['Fishing Poles'] = true,
			['Fishing Poles_BoU'] = true,
			['Fishing Poles_BoE'] = true,
			['Fishing Poles_BoP'] = false,
			['Miscellaneous'] = true,
			['Miscellaneous_BoU'] = true,
			['Miscellaneous_BoE'] = true,
			['Miscellaneous_BoP'] = true
		},
		
		['items'] = {},
	},
}

local options = {
	type = 'group',
	name = 'BetterMagnet',
	args = {   
		config = {
			type = 'execute',
			name = L['Open GUI'],
			desc = L['Opens the configuration panel'],
			guiHidden = true,
			func = function()
				InterfaceOptionsFrame:Hide()
				AceConfigDialog:SetDefaultSize('BetterMagnet', 620, 570)
				AceConfigDialog:Open('BetterMagnet')
			end
		},
		logo = {
			order = 1,
			type = 'description',
			name = '',
			image = [[Interface\Addons\BetterMagnet\BetterMagnet]],
			imageWidth = 256,
			imageHeight = 128,
			imageCoords = { 0, 1, 0, 1 },
		},
		header = {
			order = 2,
			type = 'header',
			name = L['Autoloot options'],
		},
		add = {
			order = 3,
			type = 'input',
			name = L['Add item'],
			desc = L['Adds a new item to the autoloot list'],
			usage = '<item name>',
			get  = false,
			set  = function(info,v) BetterMagnet:Print('Adding '..string.lower(v)); BetterMagnet.db.char.items[string.lower(v)] = true end
		},
		del = {
			order = 4,
			type = 'input',
			name = L['Delete item'],
			desc = L['Deletes an item from the autoloot list'],
			usage = '<item name>',
			get  = false,
			set  = function(info,v) BetterMagnet:Print('Deleting '..string.lower(v)); BetterMagnet.db.char.items[string.lower(v)] = nil end
		},
		list = {
			order = 5,
			type = 'execute',
			name = L['Show item list'],
			desc = L['Shows the list of current items to search and autoloot for'],
			func = function() BetterMagnet:Print('Autoloot list:'); for i in pairs(BetterMagnet.db.char.items) do BetterMagnet:Print(i) end end
		},
		clear = {
			order = 6,
			type = 'execute',
			name = L['Clear item list'],
			desc = L['Will clear the list of current items to search and autoloot for. THIS IS NOT UNDOABLE.'],
			func = function() BetterMagnet.db.char.items = {}; BetterMagnet:Print("Autoloot list cleared. It's empty now.") end
		},
		lootgold = {
			order = 7,
			type = 'toggle',
			name = L['Loot money'],
			desc = L['Automatically loot money too'],
			get = function() return BetterMagnet.db.char.lootGold end,
			set = function(info,v) BetterMagnet.db.char.lootGold = v end
		},
		itemsYouHave = {
			order = 8,
			type = 'toggle',
			name = L['Items You Have'],
			desc = L['Automatically loot Items you have in your bags'],
			get = function() return BetterMagnet.db.char.itemsYouHave end,
			set = function(info,v) BetterMagnet.db.char.itemsYouHave = v end
		},
		lootQuality = {
			order = 9,
			type = 'group',
			name = L['Loot by item quality'],
			desc = L['Loot items by their quality'],
			args = {
				['0'] = {
					order = 1,
					type = 'toggle',
					name = ITEM_QUALITY0_DESC,
					desc = L['Loot items with poor quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[0] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[0] = value end
				},
				['1'] = {
					order = 2,
					type = 'toggle',
					name = ITEM_QUALITY1_DESC,
					desc = L['Loot items with common quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[1] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[1] = value end
				},
				['2'] = {
					order = 3,
					type = 'toggle',
					name = ITEM_QUALITY2_DESC,
					desc = L['Loot items with uncommon quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[2] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[2] = value end
				},
				['3'] = {
					order = 4,
					type = 'toggle',
					name = ITEM_QUALITY3_DESC,
					desc = L['Loot items with rare quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[3] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[3] = value end
				},
				['4'] = {
					order = 5,
					type = 'toggle',
					name = ITEM_QUALITY4_DESC,
					desc = L['Loot items with epic quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[4] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[4] = value end
				},
				['5'] = {
					order = 6,
					type = 'toggle',
					name = ITEM_QUALITY5_DESC,
					desc = L['Loot items with legendary quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[5] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[5] = value end
				},
				['6'] = {
					order = 7,
					type = 'toggle',
					name = ITEM_QUALITY6_DESC,
					desc = L['Loot items with artifact quality'],
					get = function(info) return BetterMagnet.db.char.lootQuality[6] end,
					set = function(info, value) BetterMagnet.db.char.lootQuality[6] = value end
				},
			},
		},
		lootGoods = {
			order = 10,
			type = 'group',
			name = L['Loot Goods'],
			args = {
				Armor = {
					order = 1,
					type = 'group',
					name = ARMOR,
					args = {
						Cloth = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Cloth'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Leather = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Leather'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Mail = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Mail'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Plate = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Plate'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Idols = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Idols'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Librams = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Librams'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Shields = {
							order =  7,
							type = 'group',
							inline = true,
							name = L['Shields'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Totems = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Totems'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Sigils = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Sigils'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Miscellaneous = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Miscellaneous'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				Consumable = {
					order = 2,
					type = 'group',
					name = L['Consumable'],
					args = {
						Consumable = {
							order = 1,
							type = 'toggle',
							name = L['General'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						['Food&Drink'] = {
							order = 2,
							type = 'toggle',
							name = L['Food & Drink'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]]['Food & Drink'] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]]['Food & Drink'] = value end,
						},
						Potion = {
							order = 3,
							type = 'toggle',
							name = L['Potion'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						Elixir = {
							order = 4,
							type = 'toggle',
							name = L['Elixir'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						Flask = {
							order = 5,
							type = 'toggle',
							name = L['Flask'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						Bandage = {
							order = 6,
							type = 'toggle',
							name = L['Bandage'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						ItemEnhancements = {
							order = 7,
							type = 'toggle',
							name = L['Item Enhancements'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]]['Item Enhancements'] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]]['Item Enhancements'] = value end,
						},
						Scroll = {
							order = 8,
							type = 'toggle',
							name = L['Scroll'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						Other = {
							order = 9,
							type = 'toggle',
							name = L['Other'],
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
					},
				},
				Containers = {
					order = 3,
					type = 'group',
					name = L['Containers'],
					args = {
						Bag = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						EnchantingBag = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Enchanting Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Enchanting Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Enchanting Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Enchanting Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Enchanting Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Enchanting Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Enchanting Bag_BoP'] = value end,
								},
							},
						},
						EngineeringBag = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Engineering Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoP'] = value end,
								},
							},
						},
						EngineeringBag = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Engineering Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Engineering Bag_BoP'] = value end,
								},
							},
						},
						GemBag = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Gem Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Gem Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Gem Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Gem Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Gem Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Gem Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Gem Bag_BoP'] = value end,
								},
							},
						},
						HerbBag = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Herb Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Herb Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Herb Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Herb Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Herb Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Herb Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Herb Bag_BoP'] = value end,
								},
							},
						},
						InscriptionBag = {
							order =  7,
							type = 'group',
							inline = true,
							name = L['Inscription Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Inscription Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Inscription Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Inscription Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Inscription Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Inscription Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Inscription Bag_BoP'] = value end,
								},
							},
						},
						LeatherworkingBag = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Leatherworking Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Leatherworking Bag_BoP'] = value end,
								},
							},
						},
						MiningBag = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Mining Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Mining Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Mining Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Mining Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Mining Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Mining Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Mining Bag_BoP'] = value end,
								},
							},
						},
						SoulBag = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Soul Bag'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Soul Bag'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Soul Bag'] = value end,
								},
								boe = {
									order = 2,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Soul Bag_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Soul Bag_BoE'] = value end,
								},
								bop = {
									order = 3,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Soul Bag_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Soul Bag_BoP'] = value end,
								},
							},
						},
					},
				},
				Currency = {
					order = 4,
					type = 'toggle',
					name = CURRENCY,
					width = 'half',
					get = function(info) return BetterMagnet.db.char[info[#info]][info[#info]] end,
					set = function(info, value) BetterMagnet.db.char[info[#info]][info[#info]] = value end,
				},
				Gem = {
					order = 5,
					type = 'group',
					name = L['Gem'],
					args = {
						Red = {
							order =  1,
							type = 'group',
							inline = true,
							name = RED_GEM,
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Blue = {
							order =  2,
							type = 'group',
							inline = true,
							name = BLUE_GEM,
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Yellow = {
							order =  3,
							type = 'group',
							inline = true,
							name = YELLOW_GEM,
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Purple = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Purple Gem'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Green = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Green Gem'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Orange = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Orange Gem'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Meta = {
							order =  7,
							type = 'group',
							inline = true,
							name = META_GEM,
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Simple = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Simple Gem'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Prismatic = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Prismatic Gem'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				Key = {
					order = 6,
					type = 'toggle',
					name = L['Key'],
					width = 'half',
					get = function(info) return BetterMagnet.db.char[info[#info]][info[#info]] end,
					set = function(info, value) BetterMagnet.db.char[info[#info]][info[#info]] = value end,
				},
				Miscellaneous = {
					order = 7,
					type = 'group',
					name = L['Miscellaneous'],
					args = {
						Holiday = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Holiday'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Junk = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Junk'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Reagents = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Reagents'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Mount = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Mount'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Pet = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Pet'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Other = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Other'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				Money_OBSOLETE = {
					order = 8,
					type = 'toggle',
					name = L['Badge'],
					width = 'half',
					get = function(info) return BetterMagnet.db.char.Money['Money(OBSOLETE)'] end,
					set = function(info, value) BetterMagnet.db.char.Money['Money(OBSOLETE)'] = value end,
				},
				Quiver = {
					order = 9,
					type = 'group',
					name = L['Quiver'],
					args = {
						Quiver = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Quiver'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						AmmoPouche = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Ammo Pouche'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Ammo Pouche'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Ammo Pouche'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Ammo Pouche_BoP'] = value end,
								},
							},
						},
					},
				},
				Quest = {
					order = 10,
					type = 'group',
					name = L['Quest'],
					args = {
						Quest = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Quest'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				Projectile = {
					order = 11,
					type = 'group',
					name = L['Projectile'],
					args = {
						Arrow = {
							type = 'toggle',
							name = L['Arrow'],
							width = 'half',
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
						Bullet = {
							type = 'toggle',
							name = L['Bullet'],
							width = 'half',
							get = function(info) return BetterMagnet.db.char[info[#info-1]][info[#info]] end,
							set = function(info, value) BetterMagnet.db.char[info[#info-1]][info[#info]] = value end,
						},
					},
				},
				Recipe = {
					order = 12,
					type = 'group',
					name = L['Recipe'],
					args = {
						Book = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Book'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 1,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Alchemy = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Alchemy'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Blacksmithing = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Blacksmithing'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Cooking = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Cooking'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Enchanting = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Enchanting'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Engineering = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Engineering'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						FirstAid = {
							order =  7,
							type = 'group',
							inline = true,
							name = L['First Aid'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['First Aid'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['First Aid'] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['First Aid_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['First Aid_BoP'] = value end,
								},
							},
						},
						Fishing = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Fishing'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Jewelcrafting = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Jewelcrafting'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Leatherworking = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Leatherworking'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Tailoring = {
							order =  11,
							type = 'group',
							inline = true,
							name = L['Tailoring'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bop = {
									order = 2,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				TradeGoods = {
					order = 13,
					type = 'group',
					name = L['Trade Goods'],
					args = {
						ArmorEnchantment = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Armor Enchantment'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Armor Enchantment'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Armor Enchantment'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Armor Enchantment_BoP'] = value end,
								},
							},
						},
						Cloth = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Cloth'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Device = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Device'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Elemental = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['Elemental'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Enchanting = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['Enchanting'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Explosive = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Explosive'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Herb = {
							order =  7,
							type = 'group',
							inline = true,
							name = L['Herb'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Jewelcrafting = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Jewelcrafting'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Leather = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Leather'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Materials = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Materials'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Meat = {
							order =  11,
							type = 'group',
							inline = true,
							name = L['Meat'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						['Metal&Stone'] = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Metal & Stone'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Metal & Stone'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Metal & Stone'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Metal & Stone_BoP'] = value end,
								},
							},
						},
						Parts = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Parts'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						WeaponEnchantment = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Weapon Enchantment'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Weapon Enchantment'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Weapon Enchantment'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods']['Weapon Enchantment_BoP'] = value end,
								},
							},
						},
						Other = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Other'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char['Trade Goods'][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
				Weapon = {
					order = 14,
					type = 'group',
					name = L['Weapon'],
					args = {
						Daggers = {
							order =  1,
							type = 'group',
							inline = true,
							name = L['Daggers'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						FistWeapons = {
							order =  2,
							type = 'group',
							inline = true,
							name = L['Leather'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fist Weapons'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fist Weapons'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fist Weapons_BoP'] = value end,
								},
							},
						},
						OneHandedAxes = {
							order =  3,
							type = 'group',
							inline = true,
							name = L['Mail'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Axes'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Axes'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Axes_BoP'] = value end,
								},
							},
						},
						OneHandedMaces = {
							order =  4,
							type = 'group',
							inline = true,
							name = L['One-Handed Maces'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Maces'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Maces'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Maces_BoP'] = value end,
								},
							},
						},
						OneHandedSwords = {
							order =  5,
							type = 'group',
							inline = true,
							name = L['One-Handed Swords'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Swords'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Swords'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['One-Handed Swords_BoP'] = value end,
								},
							},
						},
						Polearms = {
							order =  6,
							type = 'group',
							inline = true,
							name = L['Polearms'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Staves = {
							order =  7,
							type = 'group',
							inline = true,
							name = L['Staves'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						TwoHandedAxes = {
							order =  8,
							type = 'group',
							inline = true,
							name = L['Mail'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Axes_BoP'] = value end,
								},
							},
						},
						TwoHandedMaces = {
							order =  9,
							type = 'group',
							inline = true,
							name = L['Two-Handed Maces'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Maces_BoP'] = value end,
								},
							},
						},
						TwoHandedSwords = {
							order =  10,
							type = 'group',
							inline = true,
							name = L['Two-Handed Swords'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Two-Handed Swords_BoP'] = value end,
								},
							},
						},
						Bows = {
							order =  11,
							type = 'group',
							inline = true,
							name = L['Bows'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Crossbows = {
							order =  12,
							type = 'group',
							inline = true,
							name = L['Crossbows'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Guns = {
							order =  13,
							type = 'group',
							inline = true,
							name = L['Guns'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						Thrown = {
							order =  14,
							type = 'group',
							inline = true,
							name = L['Thrown'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
						FishingPoles = {
							order =  15,
							type = 'group',
							inline = true,
							name = L['Fishing Poles'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fishing Poles'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fishing Poles'] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]]['Fishing Poles_BoP'] = value end,
								},
							},
						},
						Miscellaneous = {
							order =  16,
							type = 'group',
							inline = true,
							name = L['Miscellaneous'],
							args = {
								normal = {
									order = 1,
									type = 'toggle',
									name = L['normal'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1]] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1]] = value end,
								},
								bou = {
									order = 2,
									type = 'toggle',
									name = L['BoU'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoU'] = value end,
								},
								boe = {
									order = 3,
									type = 'toggle',
									name = L['BoE'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoE'] = value end,
								},
								bop = {
									order = 4,
									type = 'toggle',
									name = L['BoP'],
									width = 'half',
									get = function(info) return BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] end,
									set = function(info, value) BetterMagnet.db.char[info[#info-2]][info[#info-1] .. '_BoP'] = value end,
								},
							},
						},
					},
				},
			},
		},
	},
}

AceConfig:RegisterOptionsTable("BetterMagnet", options, "BetterMagnet")

function BetterMagnet:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BetterMagnetDB", defaults, "Default")
	AceConfigDialog:AddToBlizOptions("BetterMagnet", "BetterMagnet")
end

function BetterMagnet:OnEnable()
	self:RegisterEvent("LOOT_OPENED")
	self:RegisterEvent("BAG_UPDATE")
end

function BetterMagnet:BAG_UPDATE()
	self:UpdateCache()
end

local iCache = {
	[0] = {},
	[1] = {},
	[2] = {},
	[3] = {},
	[4] = {}
}
function BetterMagnet:UpdateCache()
	for bag = 0, 4 do
		local slots = GetContainerNumSlots(bag)
		for slot = 1, slots do
			local link = GetContainerItemLink(bag, slot)
			if not link then return end
			iCache[bag][slot] = select(1, GetItemInfo(link))
			--ChatFrame1:AddMessage(select(1, GetItemInfo(link)))
		end
	end
end

function BetterMagnet:SearchCache(itemName)
	for bag, bagV in pairs(iCache) do
		local slots = GetContainerNumSlots(bag)
		for slot in pairs(bagV) do
			if iCache[bag][slot] == itemName then
				return true
			end
		end
	end
end

-- Ripped from Xloot
local tt = CreateFrame("GameTooltip", "BetterMagnetTooltip", UIParent, "GameTooltipTemplate")
local function GetBindOn(iLink)
	tt:SetOwner(UIParent, "ANCHOR_NONE")
	tt:SetHyperlink(iLink)
	if BetterMagnetTooltip:NumLines() > 1  and BetterMagnetTooltipTextLeft2:GetText() then
		local t = BetterMagnetTooltipTextLeft2:GetText()
		tt:Hide()
		if t == ITEM_BIND_ON_PICKUP then
			return "_BoP"
		elseif t == ITEM_BIND_ON_EQUIP then
			return "_BoE"
		elseif t == ITEM_BIND_ON_USE then
			return "_BoU"
		end
	end
	tt:Hide()
end

function BetterMagnet:LOOT_OPENED()
	for i=1, GetNumLootItems() do
		if (LootSlotIsCoin(i) and self.db.char.lootGold) then
			LootSlot(i)
		elseif (LootSlotIsItem(i)) then
			local link = GetLootSlotLink(i)
			if not link then return end
			if select(5, GetLootSlotInfo(i)) then return end
			
			local itemName, _, itemRarity, _, _, iType, iSubtype = GetItemInfo(link)
			
			local bind = GetBindOn(link) or ""
			if (bind == "pickup" and itemRarity >= 3) then return end
			
			if (self.db.char.lootQuality[tostring(itemRarity)]) then
				LootSlot(i)
			elseif (self.db.char[iType][iSubtype .. bind]) then
				LootSlot(i)
			elseif (self.db.char.items[itemName]) then
				LootSlot(i)
			elseif (self:SearchCache(itemName) and self.db.profile.itemsYouHave) then
				LootSlot(i)
			elseif (self.db.char[iType][iSubtype] == nil) then
				ChatFrame1:AddMessage(tostring(iType))
				ChatFrame1:AddMessage(tostring(iSubtype))
			end
		end
	end
end

function BetterMagnet:OnDisable()
	self:UnregisterEvent("LOOT_OPENED")
end
